<?php

/**
 * A category selector object.
 *
 * @property    string      $label      Plain text label for the UI.
 * @property    string      $value      The slug saved in addon->options that identifies this selector type.
 * @property    boolean     $selected   Is this the active selector type (true).
 * @property    callable    $ui_builder The function that returns a string that will be used for the HTML output.
 *
 * @package StoreLocatorPlus\Tagalong\Category\Selector
 * @author Lance Cleveland <lance@charlestonsw.com>
 * @copyright 2015 Charleston Software Associates, LLC
 */
class SLPTagalong_Category_Selector extends SLPlus_BaseClass_Object {
    public $label;
    public $value;
    public $selected;
    public $ui_builder;

    /**
     * Create one of us.
     *
     * @param array $options
     */
    function __construct( $options ) {
        $this->uses_slplus = false;
        parent::__construct( $options );
    }
}