<?php

if ( !class_exists( 'SLP_Option' ) ) {
    require_once( 'base_class.object.php' );

    /**
     * Class SLP_Option
     *
     * A smarter SLPlus option object.
     *
     * @package   StoreLocatorPlus\Option
     * @author    Lance Cleveland <lance@charlestonsw.com>
     * @copyright 2016 Charleston Software Associates, LLC
     *
     * @property    mixed   $default_if_empty     default value if empty
     * @property    boolean $is_text              true if a gettext translatable string                                           
     * @property    string  $slug                 the slug
     * @property    boolean $use_in_javascript    use in javascript (true: gets localized in localize_script)
     * @property    mixed   $value                current value of option
     *
     * @since     4.5.09
     */
    class SLP_Option extends SLPlus_BaseClass_Object {
        public $default_if_empty = '';
        public $is_text = false;
        public $slug;
        public $use_in_javascript = false;
    }
}