<?php

/**
 * Admin Filters for Tagalong
 *
 * @property        SLPTagalong     $addon
 * @property        SLPlus          $slplus
 * @property        boolean         $filter_active      True if a filter is active.
 *
 *
 * @package StoreLocatorPlus\Admin\Filters
 * @author Lance Cleveland <lance@charlestonsw.com>
 * @copyright 2014 - 2015 Charleston Software Associates, LLC
 */
class SLPTagalong_Admin_LocationFilters extends SLPlus_BaseClass_Object {
    public $addon;
    public $slplus;
    public $filter_active = false;

    /**
     * Create the location filter form for export filters.
     */
    function createstring_LocationFilterForm() {

       $HTML = $this->addon->admin->get_CheckList(0) ;

       return
            '<div id="csa-slp-tagalong-location-filters">'               .
            apply_filters( 'slp-tag_locations_filter_ui', $HTML )   .
            '</div>'
            ;
    }

    /**
     * Extend the current where clause to also filter by the categories selected.
     *
     * @param $where
     * @return string
     */
    function filter_locations_by_category( $where ) {
        $this->addon->createobject_Data();
        $SQL_SelectStoreByCat =
            sprintf (
                $this->addon->data->get_SQL( 'where_location_has_category' ) ,
                implode( ',' , $_REQUEST['tax_input']['stores'] )
            )
        ;
        return $this->slplus->database->extend_Where( $where , $SQL_SelectStoreByCat);
    }
}

